import { _Callback, CallbackFn, IOrderable } from "./types";
import { WalkNode } from "./node";
export declare function executionOrderSort<T extends IOrderable>(a: T, b: T): 1 | 0 | -1;
export declare function unique(arr: any[]): any[];
export declare function updateObjectViaPathString(obj: any, val: any, path: string, delimiter: string): void;
export declare class CallbackStacker<T extends CallbackFn, Rt> {
    private executor;
    constructor(executor: (callbacks: _Callback<T>[], node: WalkNode) => Rt);
    private lookup;
    push(key: number, node: WalkNode, callbacks: _Callback<T>[]): void;
    executeOne(node: WalkNode, callbacks: _Callback<T>[]): Rt;
    execute(nodeId: number): Generator<Rt>;
}
